import {Character} from "../characters/Character";
import {Condition} from "./condition/Condition";

export abstract class AbstractInteraction {
  sourceCharacter: Character
  targetCharacter: Character | undefined

  conditions: Condition[] = []

  interactionLabel: string


  constructor(sourceCharacter: Character, targetCharacter: Character | undefined, interactionLabel: string) {
    this.sourceCharacter = sourceCharacter;
    this.targetCharacter = targetCharacter;
    this.interactionLabel = interactionLabel;
  }

  abstract equals(other: AbstractInteraction): boolean
  abstract validate(requieredCharacter: Character): boolean
}
